open Client

let test (env : F.nominal_datatype_env) (t : F.nominal_term) =
  Printf.printf "Formatting the System F term...\n%!";
  let doc = FPrinter.print_term t in
  Printf.printf "Pretty-printing the System F term...\n%!";
  Utils.emit_endline doc;
  let env : F.debruijn_datatype_env =
    F.translate_env env in
  print_string "Converting the System F term to de Bruijn style...\n";
  let t : F.debruijn_term =
    F.Term.translate t in
  print_string "Type-checking the System F term...\n";
  match FTypeChecker.typeof_result env t with
  | Error e ->
    Utils.emit_endline (FPrinter.print_type_error e);
    failwith "Type-checking error."
  | Ok _v -> ()
